-- On Load

gm = { w = {} }
km = { on = 2, aon = 1 }

if dos then dos:die() dos = nil end
dos = type_automaton()
dos:insert()

class "Walker"

function Walker:Walker(x,y,dx,dy)
	self.tone = newTone()
	self.x = x self.y = y
	self.dx = dx or 0 self.dy = dy or 0
	self.p = 1 self.dp = 0 self.ddp = 0
end

function Walker:insert()
	self.tone:Play(true)
	table.insert(gm.w, self)
end

function Walker:tick(refresh)
	if refresh then
		dos:set(self.x,self.y,string.char(math.random(0,127)))
		self.x = self.x + self.dx
		self.y = self.y + self.dy
		self:correct()
	end
	
	if ticks % km.aon == 0 then
		self.p = self.p + self.dp
		local ddp = 0.9*(1 - self.p)
		self.dp = self.dp + ddp
		self.tone:setPitch(self.p)
	end
end

function Walker:turn()
	local temp = self.dx self.dx = self.dy self.dy = temp
	if self.dx ~= 0 then self.dx = -self.dx end
	
	self.dp = 1
end

function Walker:correct()
	local did = false
	for i=1,4 do
		did = false
		if self.dx > 0 and self.x == 39 then self:turn() did = true end
		if self.dy > 0 and self.y == 23 then self:turn() did = true end
		if self.dx < 0 and self.x == 0 then self:turn() did = true end
		if self.dy < 0 and self.y == 0 then self:turn() did = true end
		if not did then break end
	end
end

Walker(0,0,1,0):insert()

-- Set up input handler

down = {} pressed = {}
mouseDownAt = nil
mouseAt = nil

class "Input" (EventHandler)
function Input:Input()
	self:EventHandler()
end

function cdelete(e)
	if e then delete(e) end
end

function Input:handleEvent(e)
	if e:getDispatcher() == Services.Core:getInput() then
		local inputEvent = InputEvent(e)
		local key = inputEvent:keyCode()
		if e:getEventCode() == EVENT_MOUSEMOVE then
			cdelete(mouseAt) mouseAt = inputEvent:getMousePosition()
		elseif e:getEventCode() == EVENT_MOUSEDOWN then
			cdelete(mouseDownAt) mouseDownAt = inputEvent:getMousePosition()
			cdelete(mouseAt) mouseAt = vDup(mouseDownAt)
			down[inputEvent.mouseButton] = true
			pressed[inputEvent.mouseButton] = true
		elseif e:getEventCode() == EVENT_MOUSEUP then
			down[inputEvent.mouseButton] = nil
		elseif e:getEventCode() == EVENT_KEYDOWN then
			down[key] = true
			pressed[key] = true
		elseif e:getEventCode() == EVENT_KEYUP then
			down[key] = nil
		end
	end
end

do
	input = Input()

	Services.Core:getInput():addEventListener(input, EVENT_MOUSEMOVE)
	Services.Core:getInput():addEventListener(input, EVENT_MOUSEDOWN)
	Services.Core:getInput():addEventListener(input, EVENT_MOUSEUP)
	Services.Core:getInput():addEventListener(input, EVENT_KEYDOWN)
	Services.Core:getInput():addEventListener(input, EVENT_KEYUP)
end